mescc: Add fopen test.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 94-unsetenv
142 95-signal
143 96-strto
144 97-fopen
145 "
146
147 # 90: needs GNU, fails for mescc, passes for tcc
148 broken="$broken
149 7s-struct-short
150 "
151
152 # gcc not supported
153 CC=
154 set +e
155 expect=$(echo $broken | wc -w)
156 pass=0
157 fail=0
158 total=0
159 for t in $tests; do
160     if [ -z "${t/[012][0-9]-*/}" ]; then
161         LIBC=c-mini
162         MESCCLIBS="-l c-mini"
163     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
164         LIBC=c+tcc
165         MESCCLIBS="-l c+tcc"
166     elif [ -z "${t/9[0-9]-*/}" ]; then
167         LIBC=c+gnu
168         MESCCLIBS="-l c+gnu"
169     else
170         LIBC=c
171         MESCCLIBS=
172     fi
173     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
174     r=$?
175     total=$((total+1))
176     if [ $r = 0 ]; then
177         echo $t: [OK]
178         pass=$((pass+1))
179     else
180         echo $t: [FAIL]
181         fail=$((fail+1))
182     fi
183 done
184
185 tests="
186 00_assignment
187 01_comment
188 02_printf
189 03_struct
190 04_for
191 05_array
192 06_case
193 07_function
194 08_while
195 09_do_while
196
197 10_pointer
198 11_precedence
199 12_hashdefine
200 13_integer_literals
201 14_if
202 15_recursion
203 16_nesting
204 17_enum
205 18_include
206 19_pointer_arithmetic
207
208 20_pointer_comparison
209 21_char_array
210 22_floating_point
211 23_type_coercion
212 24_math_library
213 25_quicksort
214 26_character_constants
215 27_sizeof
216 28_strings
217 29_array_address
218
219 30_hanoi
220 31_args
221 32_led
222 33_ternary_op
223 34_array_assignment
224 35_sizeof
225 36_array_initialisers
226 37_sprintf
227 38_multiple_array_index
228 39_typedef
229
230 40_stdio
231 41_hashif
232 42_function_pointer
233 43_void_param
234 44_scoped_declarations
235 45_empty_for
236 47_switch_return
237 48_nested_break
238 49_bracket_evaluation
239
240 50_logical_second_arg
241 51_static
242 52_unnamed_enum
243 54_goto
244 55_lshift_type
245 "
246
247 broken="$broken
248 18_include
249
250 22_floating_point
251 23_type_coercion
252 24_math_library
253 26_character_constants
254 27_sizeof
255 28_strings
256
257 34_array_assignment
258 39_typedef
259
260 40_stdio
261 42_function_pointer
262 49_bracket_evaluation
263 55_lshift_type
264 "
265
266 #22_floating_point       ; float
267 #23_type_coercion        ; float
268 #24_math_library         ; float
269 #27_sizeof               ; float
270 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
271 #30_hanoi                ; fails with GCC
272 #34_array_assignment     ; fails with GCC
273 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
274
275 #40_stdio                ; f* functions
276 #42_function_pointer     ; f* functions
277 #49_bracket_evaluation   ; float
278
279 LIBC=c+gnu
280 MESCCLIBS="-l c+gnu"
281
282 expect=$(echo $broken | wc -w)
283 ARGS="arg1 arg2 arg3 arg4 arg5"
284 export ARGS
285 for t in $tests; do
286     if [ ! -f scaffold/tinycc/"$t.c" ]; then
287         echo ' [SKIP]'
288         continue;
289     fi
290     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
291     r=$?
292     total=$((total+1))
293     if [ $r = 0 ]; then
294         echo $t: [OK]
295         pass=$((pass+1))
296     else
297         echo $t: [FAIL]
298         fail=$((fail+1))
299     fi
300 done
301 [ $expect != 0 ] && echo "expect: $expect"
302 [ $fail != 0 ] && echo "failed: $fail"
303 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
304 echo "passed: $pass"
305 echo "total:  $total"
306 if [ $fail != 0 -a $fail -gt $expect ]; then
307     echo FAILED: $fail/$total
308     exit 1
309 elif [ $fail != 0 ]; then
310     echo PASS: $pass/$total
311 else
312     echo PASS: $total
313 fi